/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ROTFABLOCAL                                              */
/* Tabela : ROTFABLOCAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ROTFABLOCAL'  and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
DROP TRIGGER DTULTATU_ROTFABLOCAL
GO

CREATE TRIGGER DTULTATU_ROTFABLOCAL
ON ROTFABLOCAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ROTFABLOCAL', CDFILIAL, 'CDFILIAL='+ CDFILIAL+
                                                ';CDPRODUTO='+ CDPRODUTO+
                                                ';CDSUBPRODLOC='+ CDSUBPRODLOC+
                                                ';NRSEQROTFABLOC='+NRSEQROTFABLOC+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ROTFABLOCAL
      SET DTULTATURTFL = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ROTFABLOCAL.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(ROTFABLOCAL.CDFILIAL,0)  = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(ROTFABLOCAL.CDSUBPRODLOC,0) = ISNULL(INSERTED.CDSUBPRODLOC,0)) AND
            (ISNULL(ROTFABLOCAL.NRSEQROTFABLOC,0) = ISNULL(INSERTED.NRSEQROTFABLOC,0));
   END;
END;
GO


UPDATE ROTFABLOCAL SET DTULTATURTFL = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATURTFL IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATURTFL' and
            type = 'D')
   ALTER TABLE ROTFABLOCAL DROP CONSTRAINT DEFAULT_DTULTATURTFL
GO

ALTER TABLE ROTFABLOCAL ADD CONSTRAINT DEFAULT_DTULTATURTFL
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATURTFL
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ROTFABLOCAL','6.39.030';
GO

